#!/bin/bash

# Copyright (C) 2016, 2018  Stefan Vargyas
# 
# This file is part of Trie-Gen.
# 
# Trie-Gen is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# Trie-Gen is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with Trie-Gen.  If not, see <http://www.gnu.org/licenses/>.

#
# File generated by a command like:
# $ gen-test -T print-obj-alphabets-array
#

[[ "$1" =~ ^-u[0-9]+$ ]] &&
u="${1:2}" ||
u=""

diff -u$u -L print-obj-alphabets-array.old <(echo \
'$ print() { printf '\''%s\n'\'' "$@"; }
$ ../src/trie --attrs --dots --output=object --trie=array < alphabets.txt
[25,'\''z'\''] {
.   '\''a'\'' [8,'\''z'\''] {
.   .   '\''a'\'': "aa"
.   .   '\''f'\'': "af"
.   .   '\''g'\'' [1,'\''q'\''] {
.   .   .   '\''q'\'': "agq"
.   .   }
.   .   '\''k'\'': "ak"
.   .   '\''m'\'': "am"
.   .   '\''r'\'': "ar"
.   .   '\''s'\'': "as" [2,'\''t'\''] {
.   .   .   '\''a'\'': "asa"
.   .   .   '\''t'\'': "ast"
.   .   }
.   .   '\''z'\'': "az" [1,'\''_'\''] {
.   .   .   '\''_'\'' [1,'\''C'\''] {
.   .   .   .   '\''C'\'' [1,'\''y'\''] {
.   .   .   .   .   '\''y'\'' [1,'\''r'\''] {
.   .   .   .   .   .   '\''r'\'' [1,'\''l'\''] {
.   .   .   .   .   .   .   '\''l'\'': "az_Cyrl"
.   .   .   .   .   .   }
.   .   .   .   .   }
.   .   .   .   }
.   .   .   }
.   .   }
.   }
.   '\''b'\'' [9,'\''y'\''] {
.   .   '\''a'\'' [1,'\''s'\''] {
.   .   .   '\''s'\'': "bas"
.   .   }
.   .   '\''e'\'': "be" [2,'\''z'\''] {
.   .   .   '\''m'\'': "bem"
.   .   .   '\''z'\'': "bez"
.   .   }
.   .   '\''g'\'': "bg"
.   .   '\''m'\'': "bm"
.   .   '\''n'\'': "bn"
.   .   '\''o'\'': "bo"
.   .   '\''r'\'': "br" [1,'\''x'\''] {
.   .   .   '\''x'\'': "brx"
.   .   }
.   .   '\''s'\'': "bs" [1,'\''_'\''] {
.   .   .   '\''_'\'' [1,'\''C'\''] {
.   .   .   .   '\''C'\'' [1,'\''y'\''] {
.   .   .   .   .   '\''y'\'' [1,'\''r'\''] {
.   .   .   .   .   .   '\''r'\'' [1,'\''l'\''] {
.   .   .   .   .   .   .   '\''l'\'': "bs_Cyrl"
.   .   .   .   .   .   }
.   .   .   .   .   }
.   .   .   .   }
.   .   .   }
.   .   }
.   .   '\''y'\'' [1,'\''n'\''] {
.   .   .   '\''n'\'': "byn"
.   .   }
.   }
.   '\''c'\'' [5,'\''y'\''] {
.   .   '\''a'\'': "ca"
.   .   '\''g'\'' [1,'\''g'\''] {
.   .   .   '\''g'\'': "cgg"
.   .   }
.   .   '\''h'\'' [1,'\''r'\''] {
.   .   .   '\''r'\'': "chr"
.   .   }
.   .   '\''s'\'': "cs"
.   .   '\''y'\'': "cy"
.   }
.   '\''d'\'' [6,'\''z'\''] {
.   .   '\''a'\'': "da" [1,'\''v'\''] {
.   .   .   '\''v'\'': "dav"
.   .   }
.   .   '\''e'\'': "de"
.   .   '\''j'\'' [1,'\''e'\''] {
.   .   .   '\''e'\'': "dje"
.   .   }
.   .   '\''u'\'' [1,'\''a'\''] {
.   .   .   '\''a'\'': "dua"
.   .   }
.   .   '\''y'\'' [1,'\''o'\''] {
.   .   .   '\''o'\'': "dyo"
.   .   }
.   .   '\''z'\'': "dz"
.   }
.   '\''e'\'' [9,'\''w'\''] {
.   .   '\''b'\'' [1,'\''u'\''] {
.   .   .   '\''u'\'': "ebu"
.   .   }
.   .   '\''e'\'': "ee"
.   .   '\''l'\'': "el"
.   .   '\''n'\'': "en"
.   .   '\''o'\'': "eo"
.   .   '\''s'\'': "es"
.   .   '\''t'\'': "et"
.   .   '\''u'\'': "eu"
.   .   '\''w'\'' [1,'\''o'\''] {
.   .   .   '\''o'\'': "ewo"
.   .   }
.   }
.   '\''f'\'' [7,'\''y'\''] {
.   .   '\''a'\'': "fa"
.   .   '\''f'\'': "ff"
.   .   '\''i'\'': "fi" [1,'\''l'\''] {
.   .   .   '\''l'\'': "fil"
.   .   }
.   .   '\''o'\'': "fo"
.   .   '\''r'\'': "fr"
.   .   '\''u'\'' [1,'\''r'\''] {
.   .   .   '\''r'\'': "fur"
.   .   }
.   .   '\''y'\'': "fy"
.   }
.   '\''g'\'' [6,'\''v'\''] {
.   .   '\''a'\'': "ga"
.   .   '\''d'\'': "gd"
.   .   '\''l'\'': "gl"
.   .   '\''s'\'' [1,'\''w'\''] {
.   .   .   '\''w'\'': "gsw"
.   .   }
.   .   '\''u'\'': "gu" [1,'\''z'\''] {
.   .   .   '\''z'\'': "guz"
.   .   }
.   .   '\''v'\'': "gv"
.   }
.   '\''h'\'' [6,'\''y'\''] {
.   .   '\''a'\'': "ha" [1,'\''w'\''] {
.   .   .   '\''w'\'': "haw"
.   .   }
.   .   '\''e'\'': "he"
.   .   '\''i'\'': "hi"
.   .   '\''r'\'': "hr"
.   .   '\''u'\'': "hu"
.   .   '\''y'\'': "hy"
.   }
.   '\''i'\'' [6,'\''t'\''] {
.   .   '\''a'\'': "ia"
.   .   '\''d'\'': "id"
.   .   '\''g'\'': "ig"
.   .   '\''i'\'': "ii"
.   .   '\''s'\'': "is"
.   .   '\''t'\'': "it"
.   }
.   '\''j'\'' [3,'\''m'\''] {
.   .   '\''a'\'': "ja"
.   .   '\''g'\'' [1,'\''o'\''] {
.   .   .   '\''o'\'': "jgo"
.   .   }
.   .   '\''m'\'' [1,'\''c'\''] {
.   .   .   '\''c'\'': "jmc"
.   .   }
.   }
.   '\''k'\'' [13,'\''y'\''] {
.   .   '\''a'\'': "ka" [2,'\''m'\''] {
.   .   .   '\''b'\'': "kab"
.   .   .   '\''m'\'': "kam"
.   .   }
.   .   '\''d'\'' [1,'\''e'\''] {
.   .   .   '\''e'\'': "kde"
.   .   }
.   .   '\''e'\'' [1,'\''a'\''] {
.   .   .   '\''a'\'': "kea"
.   .   }
.   .   '\''h'\'' [1,'\''q'\''] {
.   .   .   '\''q'\'': "khq"
.   .   }
.   .   '\''i'\'': "ki"
.   .   '\''k'\'': "kk" [1,'\''j'\''] {
.   .   .   '\''j'\'': "kkj"
.   .   }
.   .   '\''l'\'': "kl" [1,'\''n'\''] {
.   .   .   '\''n'\'': "kln"
.   .   }
.   .   '\''m'\'': "km"
.   .   '\''n'\'': "kn"
.   .   '\''o'\'': "ko" [1,'\''k'\''] {
.   .   .   '\''k'\'': "kok"
.   .   }
.   .   '\''s'\'' [3,'\''h'\''] {
.   .   .   '\''b'\'': "ksb"
.   .   .   '\''f'\'': "ksf"
.   .   .   '\''h'\'': "ksh"
.   .   }
.   .   '\''w'\'': "kw"
.   .   '\''y'\'': "ky"
.   }
.   '\''l'\'' [8,'\''v'\''] {
.   .   '\''a'\'' [1,'\''g'\''] {
.   .   .   '\''g'\'': "lag"
.   .   }
.   .   '\''g'\'': "lg"
.   .   '\''k'\'' [1,'\''t'\''] {
.   .   .   '\''t'\'': "lkt"
.   .   }
.   .   '\''n'\'': "ln"
.   .   '\''o'\'': "lo"
.   .   '\''t'\'': "lt"
.   .   '\''u'\'': "lu" [2,'\''y'\''] {
.   .   .   '\''o'\'': "luo"
.   .   .   '\''y'\'': "luy"
.   .   }
.   .   '\''v'\'': "lv"
.   }
.   '\''m'\'' [12,'\''y'\''] {
.   .   '\''a'\'' [1,'\''s'\''] {
.   .   .   '\''s'\'': "mas"
.   .   }
.   .   '\''e'\'' [1,'\''r'\''] {
.   .   .   '\''r'\'': "mer"
.   .   }
.   .   '\''f'\'' [1,'\''e'\''] {
.   .   .   '\''e'\'': "mfe"
.   .   }
.   .   '\''g'\'': "mg" [2,'\''o'\''] {
.   .   .   '\''h'\'': "mgh"
.   .   .   '\''o'\'': "mgo"
.   .   }
.   .   '\''k'\'': "mk"
.   .   '\''l'\'': "ml"
.   .   '\''n'\'': "mn"
.   .   '\''r'\'': "mr"
.   .   '\''s'\'': "ms"
.   .   '\''t'\'': "mt"
.   .   '\''u'\'' [1,'\''a'\''] {
.   .   .   '\''a'\'': "mua"
.   .   }
.   .   '\''y'\'': "my"
.   }
.   '\''n'\'' [11,'\''y'\''] {
.   .   '\''a'\'' [1,'\''q'\''] {
.   .   .   '\''q'\'': "naq"
.   .   }
.   .   '\''b'\'': "nb"
.   .   '\''d'\'': "nd"
.   .   '\''e'\'': "ne"
.   .   '\''l'\'': "nl"
.   .   '\''m'\'' [1,'\''g'\''] {
.   .   .   '\''g'\'': "nmg"
.   .   }
.   .   '\''n'\'': "nn" [1,'\''h'\''] {
.   .   .   '\''h'\'': "nnh"
.   .   }
.   .   '\''r'\'': "nr"
.   .   '\''s'\'' [1,'\''o'\''] {
.   .   .   '\''o'\'': "nso"
.   .   }
.   .   '\''u'\'' [1,'\''s'\''] {
.   .   .   '\''s'\'': "nus"
.   .   }
.   .   '\''y'\'' [1,'\''n'\''] {
.   .   .   '\''n'\'': "nyn"
.   .   }
.   }
.   '\''o'\'' [3,'\''s'\''] {
.   .   '\''m'\'': "om"
.   .   '\''r'\'': "or"
.   .   '\''s'\'': "os"
.   }
.   '\''p'\'' [4,'\''t'\''] {
.   .   '\''a'\'': "pa" [1,'\''_'\''] {
.   .   .   '\''_'\'' [1,'\''A'\''] {
.   .   .   .   '\''A'\'' [1,'\''r'\''] {
.   .   .   .   .   '\''r'\'' [1,'\''a'\''] {
.   .   .   .   .   .   '\''a'\'' [1,'\''b'\''] {
.   .   .   .   .   .   .   '\''b'\'': "pa_Arab"
.   .   .   .   .   .   }
.   .   .   .   .   }
.   .   .   .   }
.   .   .   }
.   .   }
.   .   '\''l'\'': "pl"
.   .   '\''s'\'': "ps"
.   .   '\''t'\'': "pt"
.   }
.   '\''r'\'' [5,'\''w'\''] {
.   .   '\''m'\'': "rm"
.   .   '\''n'\'': "rn"
.   .   '\''o'\'': "ro" [1,'\''f'\''] {
.   .   .   '\''f'\'': "rof"
.   .   }
.   .   '\''u'\'': "ru"
.   .   '\''w'\'': "rw" [1,'\''k'\''] {
.   .   .   '\''k'\'': "rwk"
.   .   }
.   }
.   '\''s'\'' [16,'\''w'\''] {
.   .   '\''a'\'' [2,'\''q'\''] {
.   .   .   '\''h'\'': "sah"
.   .   .   '\''q'\'': "saq"
.   .   }
.   .   '\''b'\'' [1,'\''p'\''] {
.   .   .   '\''p'\'': "sbp"
.   .   }
.   .   '\''e'\'': "se" [2,'\''s'\''] {
.   .   .   '\''h'\'': "seh"
.   .   .   '\''s'\'': "ses"
.   .   }
.   .   '\''g'\'': "sg"
.   .   '\''h'\'' [1,'\''i'\''] {
.   .   .   '\''i'\'': "shi" [1,'\''_'\''] {
.   .   .   .   '\''_'\'' [1,'\''L'\''] {
.   .   .   .   .   '\''L'\'' [1,'\''a'\''] {
.   .   .   .   .   .   '\''a'\'' [1,'\''t'\''] {
.   .   .   .   .   .   .   '\''t'\'' [1,'\''n'\''] {
.   .   .   .   .   .   .   .   '\''n'\'': "shi_Latn"
.   .   .   .   .   .   .   }
.   .   .   .   .   .   }
.   .   .   .   .   }
.   .   .   .   }
.   .   .   }
.   .   }
.   .   '\''i'\'': "si"
.   .   '\''k'\'': "sk"
.   .   '\''l'\'': "sl"
.   .   '\''n'\'': "sn"
.   .   '\''o'\'': "so"
.   .   '\''q'\'': "sq"
.   .   '\''r'\'': "sr" [1,'\''_'\''] {
.   .   .   '\''_'\'' [1,'\''L'\''] {
.   .   .   .   '\''L'\'' [1,'\''a'\''] {
.   .   .   .   .   '\''a'\'' [1,'\''t'\''] {
.   .   .   .   .   .   '\''t'\'' [1,'\''n'\''] {
.   .   .   .   .   .   .   '\''n'\'': "sr_Latn"
.   .   .   .   .   .   }
.   .   .   .   .   }
.   .   .   .   }
.   .   .   }
.   .   }
.   .   '\''s'\'': "ss" [1,'\''y'\''] {
.   .   .   '\''y'\'': "ssy"
.   .   }
.   .   '\''t'\'': "st"
.   .   '\''v'\'': "sv"
.   .   '\''w'\'': "sw" [1,'\''c'\''] {
.   .   .   '\''c'\'': "swc"
.   .   }
.   }
.   '\''t'\'' [11,'\''z'\''] {
.   .   '\''a'\'': "ta"
.   .   '\''e'\'': "te" [1,'\''o'\''] {
.   .   .   '\''o'\'': "teo"
.   .   }
.   .   '\''g'\'': "tg"
.   .   '\''h'\'': "th"
.   .   '\''i'\'': "ti" [2,'\''g'\''] {
.   .   .   '\''_'\'' [1,'\''E'\''] {
.   .   .   .   '\''E'\'' [1,'\''R'\''] {
.   .   .   .   .   '\''R'\'': "ti_ER"
.   .   .   .   }
.   .   .   }
.   .   .   '\''g'\'': "tig"
.   .   }
.   .   '\''n'\'': "tn"
.   .   '\''o'\'': "to"
.   .   '\''r'\'': "tr"
.   .   '\''s'\'': "ts"
.   .   '\''w'\'' [1,'\''q'\''] {
.   .   .   '\''q'\'': "twq"
.   .   }
.   .   '\''z'\'' [1,'\''m'\''] {
.   .   .   '\''m'\'': "tzm"
.   .   }
.   }
.   '\''u'\'' [4,'\''z'\''] {
.   .   '\''g'\'': "ug"
.   .   '\''k'\'': "uk"
.   .   '\''r'\'': "ur"
.   .   '\''z'\'': "uz" [1,'\''_'\''] {
.   .   .   '\''_'\'' [2,'\''C'\''] {
.   .   .   .   '\''A'\'' [1,'\''r'\''] {
.   .   .   .   .   '\''r'\'' [1,'\''a'\''] {
.   .   .   .   .   .   '\''a'\'' [1,'\''b'\''] {
.   .   .   .   .   .   .   '\''b'\'': "uz_Arab"
.   .   .   .   .   .   }
.   .   .   .   .   }
.   .   .   .   }
.   .   .   .   '\''C'\'' [1,'\''y'\''] {
.   .   .   .   .   '\''y'\'' [1,'\''r'\''] {
.   .   .   .   .   .   '\''r'\'' [1,'\''l'\''] {
.   .   .   .   .   .   .   '\''l'\'': "uz_Cyrl"
.   .   .   .   .   .   }
.   .   .   .   .   }
.   .   .   .   }
.   .   .   }
.   .   }
.   }
.   '\''v'\'' [5,'\''u'\''] {
.   .   '\''a'\'' [1,'\''i'\''] {
.   .   .   '\''i'\'' [1,'\''_'\''] {
.   .   .   .   '\''_'\'' [1,'\''L'\''] {
.   .   .   .   .   '\''L'\'' [1,'\''a'\''] {
.   .   .   .   .   .   '\''a'\'' [1,'\''t'\''] {
.   .   .   .   .   .   .   '\''t'\'' [1,'\''n'\''] {
.   .   .   .   .   .   .   .   '\''n'\'': "vai_Latn"
.   .   .   .   .   .   .   }
.   .   .   .   .   .   }
.   .   .   .   .   }
.   .   .   .   }
.   .   .   }
.   .   }
.   .   '\''e'\'': "ve"
.   .   '\''i'\'': "vi"
.   .   '\''o'\'': "vo"
.   .   '\''u'\'' [1,'\''n'\''] {
.   .   .   '\''n'\'': "vun"
.   .   }
.   }
.   '\''w'\'' [1,'\''a'\''] {
.   .   '\''a'\'' [2,'\''l'\''] {
.   .   .   '\''e'\'': "wae"
.   .   .   '\''l'\'': "wal"
.   .   }
.   }
.   '\''x'\'' [2,'\''o'\''] {
.   .   '\''h'\'': "xh"
.   .   '\''o'\'' [1,'\''g'\''] {
.   .   .   '\''g'\'': "xog"
.   .   }
.   }
.   '\''y'\'' [2,'\''o'\''] {
.   .   '\''a'\'' [1,'\''v'\''] {
.   .   .   '\''v'\'': "yav"
.   .   }
.   .   '\''o'\'': "yo" [1,'\''_'\''] {
.   .   .   '\''_'\'' [1,'\''B'\''] {
.   .   .   .   '\''B'\'' [1,'\''J'\''] {
.   .   .   .   .   '\''J'\'': "yo_BJ"
.   .   .   .   }
.   .   .   }
.   .   }
.   }
.   '\''z'\'' [3,'\''u'\''] {
.   .   '\''g'\'' [1,'\''h'\''] {
.   .   .   '\''h'\'': "zgh"
.   .   }
.   .   '\''h'\'': "zh" [1,'\''_'\''] {
.   .   .   '\''_'\'' [1,'\''H'\''] {
.   .   .   .   '\''H'\'' [1,'\''a'\''] {
.   .   .   .   .   '\''a'\'' [1,'\''n'\''] {
.   .   .   .   .   .   '\''n'\'' [1,'\''t'\''] {
.   .   .   .   .   .   .   '\''t'\'': "zh_Hant"
.   .   .   .   .   .   }
.   .   .   .   .   }
.   .   .   .   }
.   .   .   }
.   .   }
.   .   '\''u'\'': "zu"
.   }
}'
) -L print-obj-alphabets-array.new <(
echo '$ print() { printf '\''%s\n'\'' "$@"; }'
print() { printf '%s\n' "$@"; } 2>&1 ||
echo 'command failed: print() { printf '\''%s\n'\'' "$@"; }'

echo '$ ../src/trie --attrs --dots --output=object --trie=array < alphabets.txt'
../src/trie --attrs --dots --output=object --trie=array < alphabets.txt 2>&1 ||
echo 'command failed: ../src/trie --attrs --dots --output=object --trie=array < alphabets.txt'
)

